#pragma once

#include "finder.h"
#include "word_list.h"

#include <map>

class Bucket {
private:
  std::map<const char, WordRefList> groups_;

public:
  void insert(const WordList &word_list, size_t first_index, size_t last_index);

  std::forward_list<const std::string *>
  find_prefix(std::string_view search_term) const;
};

class BucketFinder : public Finder {
private:
  std::vector<Bucket> buckets_;

public:
  BucketFinder(const WordList &word_list);

  std::forward_list<const std::string *>
  find_prefix(std::string_view search_term) const override;
};
